
/*
This file has been generated by Polychrony version 4.23
*/
#include "equationSolving_types.h"
#include "equationSolving_externals.h"
#include "equationSolving_body.h"

/*
  ==> parameters and indexes 
*/
/*
  ==> input signals     
*/
static float a, b, c;
/*
  ==> output signals    
*/
static float x2, x1;
static boolean oc;
/*
  ==> local signals     
*/
static boolean err2;
static float a1;
static boolean OK, stable;
static float bb, dd;
static boolean biterate;
static float next_yy, yy, mx;
static boolean next_stable;
static float L158_next_stable_subexpr, s;
static boolean L266_CLK_73, L271_x1, L282_extended_OK, L284_bb, L286_err2, L289_extended_err2, L292_bb1, L298_extended_bb1, L303_d, L309_extended_d, 
               L314_x_subexpr, L320_extended_x_subexpr, L325_err1, L328_extended_err1, C_a1, C_x1, C_oc;
static boolean pK_microstep;

EXTERN boolean equationSolving_initialize()
{
    stable = pk_true;
    bb = 0.0e0;
    mx = 0.0e0;
    next_yy = 1.0;
    equationSolving_step_initialize();
    return pk_true;
}

static void equationSolving_step_initialize()
{
    OK = pk_false;
    L284_bb = pk_false;
    L292_bb1 = pk_false;
    L303_d = pk_false;
    L314_x_subexpr = pk_false;
}

EXTERN boolean equationSolving_step()
{
    do{
    /*
     ENDOCHRONOUS with internal ROOT CLOCK 
    */
    if (stable)
        {
        if (!r_equationSolving_a(&a)) return pk_false;
        if (!r_equationSolving_b(&b)) return pk_false;
        if (!r_equationSolving_c(&c)) return pk_false;
        OK = a != 0.0;
        L284_bb = !OK;
        if (OK)
            {
            bb = b / a;
            dd = bb * bb - 4.0 * (c / a);
            L303_d = dd > 0.0;
            L314_x_subexpr = dd == 0.0;
            L325_err1 = dd < 0.0;
            }
        L328_extended_err1 = (OK ? L325_err1 : pk_false);
        if (L284_bb)
            {
            L286_err2 = b == 0.0;
            L292_bb1 = !L286_err2;
            if (L286_err2)
                {
                err2 = c != 0.0;
                }
            }
        L289_extended_err2 = (L284_bb ? L286_err2 : pk_false);
        C_oc = L328_extended_err1 || L289_extended_err2;
        if (C_oc)
            {
            if (L325_err1) oc = pk_true; else oc = err2; 
            w_equationSolving_oc(oc);
            }
        }
    L282_extended_OK = (stable ? OK : pk_false);
    L298_extended_bb1 = (L284_bb ? L292_bb1 : pk_false);
    L309_extended_d = (OK ? L303_d : pk_false);
    if (stable)
        {
        if (OK)
            {
            if (L303_d)
                {
                mx = dd;
                }
            }
        }
    L320_extended_x_subexpr = (OK ? L314_x_subexpr : pk_false);
    if (L303_d) biterate = pk_true; else biterate = !stable; 
    if (L303_d) yy = dd / 2.0; else yy = next_yy; 
    if (biterate) next_yy = (yy + mx / yy) / 2.0; else next_yy = yy; 
    L158_next_stable_subexpr = next_yy - yy;
    L266_CLK_73 = L158_next_stable_subexpr >= 0.0;
    if (L266_CLK_73) s = L158_next_stable_subexpr; else s = -L158_next_stable_subexpr; 
    next_stable = s < (0.00001);
    L271_x1 = next_stable && biterate;
    C_a1 = L271_x1 || L320_extended_x_subexpr;
    C_x1 = C_a1 || L298_extended_bb1;
    if (L271_x1)
        {
        x2 = -((bb - yy) / 2.0);
        w_equationSolving_x2(x2);
        }
    if (C_a1)
        {
        if (L271_x1) a1 = -((bb + yy) / 2.0); else a1 = -bb / 2.0; 
        }
    if (C_x1)
        {
        if (C_a1) x1 = a1; else x1 = -(c / b); 
        w_equationSolving_x1(x1);
        }
    pK_microstep = !(L271_x1 || stable);
    equationSolving_step_finalize();
    } while (pK_microstep);
    return pk_true;
}

EXTERN boolean equationSolving_step_finalize()
{
    stable = next_stable;
    L286_err2 = pk_false;
    L325_err1 = pk_false;
    equationSolving_step_initialize();
    return pk_true;
}

